var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/http/responses.ts
var responses_exports = {};
__export(responses_exports, {
  HttpResponse: () => HttpResponse,
  HttpResponseBadRequest: () => HttpResponseBadRequest,
  HttpResponseClientError: () => HttpResponseClientError,
  HttpResponseConflict: () => HttpResponseConflict,
  HttpResponseCreated: () => HttpResponseCreated,
  HttpResponseForbidden: () => HttpResponseForbidden,
  HttpResponseInternalServerError: () => HttpResponseInternalServerError,
  HttpResponseMethodNotAllowed: () => HttpResponseMethodNotAllowed,
  HttpResponseMovedPermanently: () => HttpResponseMovedPermanently,
  HttpResponseNoContent: () => HttpResponseNoContent,
  HttpResponseNotFound: () => HttpResponseNotFound,
  HttpResponseNotImplemented: () => HttpResponseNotImplemented,
  HttpResponseOK: () => HttpResponseOK,
  HttpResponseRedirect: () => HttpResponseRedirect,
  HttpResponseRedirection: () => HttpResponseRedirection,
  HttpResponseServerError: () => HttpResponseServerError,
  HttpResponseSuccess: () => HttpResponseSuccess,
  HttpResponseTooManyRequests: () => HttpResponseTooManyRequests,
  HttpResponseUnauthorized: () => HttpResponseUnauthorized,
  isHttpResponse: () => isHttpResponse,
  isHttpResponseBadRequest: () => isHttpResponseBadRequest,
  isHttpResponseClientError: () => isHttpResponseClientError,
  isHttpResponseConflict: () => isHttpResponseConflict,
  isHttpResponseCreated: () => isHttpResponseCreated,
  isHttpResponseForbidden: () => isHttpResponseForbidden,
  isHttpResponseInternalServerError: () => isHttpResponseInternalServerError,
  isHttpResponseMethodNotAllowed: () => isHttpResponseMethodNotAllowed,
  isHttpResponseMovedPermanently: () => isHttpResponseMovedPermanently,
  isHttpResponseNoContent: () => isHttpResponseNoContent,
  isHttpResponseNotFound: () => isHttpResponseNotFound,
  isHttpResponseNotImplemented: () => isHttpResponseNotImplemented,
  isHttpResponseOK: () => isHttpResponseOK,
  isHttpResponseRedirect: () => isHttpResponseRedirect,
  isHttpResponseRedirection: () => isHttpResponseRedirection,
  isHttpResponseServerError: () => isHttpResponseServerError,
  isHttpResponseSuccess: () => isHttpResponseSuccess,
  isHttpResponseTooManyRequests: () => isHttpResponseTooManyRequests,
  isHttpResponseUnauthorized: () => isHttpResponseUnauthorized
});
module.exports = __toCommonJS(responses_exports);
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
function isHttpResponse(obj) {
  return obj instanceof HttpResponse || typeof obj === "object" && obj !== null && obj.isHttpResponse === true;
}
var HttpResponseSuccess = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseSuccess = true;
  }
};
function isHttpResponseSuccess(obj) {
  return obj instanceof HttpResponseSuccess || typeof obj === "object" && obj !== null && obj.isHttpResponseSuccess === true;
}
var HttpResponseOK = class extends HttpResponseSuccess {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseOK = true;
    this.statusCode = 200;
    this.statusMessage = "OK";
  }
};
function isHttpResponseOK(obj) {
  return obj instanceof HttpResponseOK || typeof obj === "object" && obj !== null && obj.isHttpResponseOK === true;
}
var HttpResponseCreated = class extends HttpResponseSuccess {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseCreated = true;
    this.statusCode = 201;
    this.statusMessage = "CREATED";
  }
};
function isHttpResponseCreated(obj) {
  return obj instanceof HttpResponseCreated || typeof obj === "object" && obj !== null && obj.isHttpResponseCreated === true;
}
var HttpResponseNoContent = class extends HttpResponseSuccess {
  constructor() {
    super();
    this.isHttpResponseNoContent = true;
    this.statusCode = 204;
    this.statusMessage = "NO CONTENT";
  }
};
function isHttpResponseNoContent(obj) {
  return obj instanceof HttpResponseNoContent || typeof obj === "object" && obj !== null && obj.isHttpResponseNoContent === true;
}
var HttpResponseRedirection = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseRedirection = true;
  }
};
function isHttpResponseRedirection(obj) {
  return obj instanceof HttpResponseRedirection || typeof obj === "object" && obj !== null && obj.isHttpResponseRedirection === true;
}
var HttpResponseMovedPermanently = class extends HttpResponseRedirection {
  constructor(path) {
    super();
    this.path = path;
    this.isHttpResponseMovedPermanently = true;
    this.statusCode = 301;
    this.statusMessage = "MOVED PERMANENTLY";
  }
};
function isHttpResponseMovedPermanently(obj) {
  return obj instanceof HttpResponseMovedPermanently || typeof obj === "object" && obj !== null && obj.isHttpResponseMovedPermanently === true;
}
var HttpResponseRedirect = class extends HttpResponseRedirection {
  constructor(path, body, options = {}) {
    super(body, options);
    this.path = path;
    this.isHttpResponseRedirect = true;
    this.statusCode = 302;
    this.statusMessage = "FOUND";
  }
};
function isHttpResponseRedirect(obj) {
  return obj instanceof HttpResponseRedirect || typeof obj === "object" && obj !== null && obj.isHttpResponseRedirect === true;
}
var HttpResponseClientError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseClientError = true;
  }
};
function isHttpResponseClientError(obj) {
  return obj instanceof HttpResponseClientError || typeof obj === "object" && obj !== null && obj.isHttpResponseClientError === true;
}
var HttpResponseBadRequest = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseBadRequest = true;
    this.statusCode = 400;
    this.statusMessage = "BAD REQUEST";
  }
};
function isHttpResponseBadRequest(obj) {
  return obj instanceof HttpResponseBadRequest || typeof obj === "object" && obj !== null && obj.isHttpResponseBadRequest === true;
}
var HttpResponseUnauthorized = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseUnauthorized = true;
    this.statusCode = 401;
    this.statusMessage = "UNAUTHORIZED";
    this.setHeader("WWW-Authenticate", "");
  }
};
function isHttpResponseUnauthorized(obj) {
  return obj instanceof HttpResponseUnauthorized || typeof obj === "object" && obj !== null && obj.isHttpResponseUnauthorized === true;
}
var HttpResponseForbidden = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseForbidden = true;
    this.statusCode = 403;
    this.statusMessage = "FORBIDDEN";
  }
};
function isHttpResponseForbidden(obj) {
  return obj instanceof HttpResponseForbidden || typeof obj === "object" && obj !== null && obj.isHttpResponseForbidden === true;
}
var HttpResponseNotFound = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseNotFound = true;
    this.statusCode = 404;
    this.statusMessage = "NOT FOUND";
  }
};
function isHttpResponseNotFound(obj) {
  return obj instanceof HttpResponseNotFound || typeof obj === "object" && obj !== null && obj.isHttpResponseNotFound === true;
}
var HttpResponseMethodNotAllowed = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseMethodNotAllowed = true;
    this.statusCode = 405;
    this.statusMessage = "METHOD NOT ALLOWED";
  }
};
function isHttpResponseMethodNotAllowed(obj) {
  return obj instanceof HttpResponseMethodNotAllowed || typeof obj === "object" && obj !== null && obj.isHttpResponseMethodNotAllowed === true;
}
var HttpResponseConflict = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseConflict = true;
    this.statusCode = 409;
    this.statusMessage = "CONFLICT";
  }
};
function isHttpResponseConflict(obj) {
  return obj instanceof HttpResponseConflict || typeof obj === "object" && obj !== null && obj.isHttpResponseConflict === true;
}
var HttpResponseTooManyRequests = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseTooManyRequests = true;
    this.statusCode = 429;
    this.statusMessage = "TOO MANY REQUESTS";
  }
};
function isHttpResponseTooManyRequests(obj) {
  return obj instanceof HttpResponseTooManyRequests || typeof obj === "object" && obj !== null && obj.isHttpResponseTooManyRequests === true;
}
var HttpResponseServerError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseServerError = true;
  }
};
function isHttpResponseServerError(obj) {
  return obj instanceof HttpResponseServerError || typeof obj === "object" && obj !== null && obj.isHttpResponseServerError === true;
}
var HttpResponseInternalServerError = class extends HttpResponseServerError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseInternalServerError = true;
    this.statusCode = 500;
    this.statusMessage = "INTERNAL SERVER ERROR";
  }
};
function isHttpResponseInternalServerError(obj) {
  return obj instanceof HttpResponseInternalServerError || typeof obj === "object" && obj !== null && obj.isHttpResponseInternalServerError === true;
}
var HttpResponseNotImplemented = class extends HttpResponseServerError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseNotImplemented = true;
    this.statusCode = 501;
    this.statusMessage = "NOT IMPLEMENTED";
  }
};
function isHttpResponseNotImplemented(obj) {
  return obj instanceof HttpResponseNotImplemented || typeof obj === "object" && obj !== null && obj.isHttpResponseNotImplemented === true;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  HttpResponse,
  HttpResponseBadRequest,
  HttpResponseClientError,
  HttpResponseConflict,
  HttpResponseCreated,
  HttpResponseForbidden,
  HttpResponseInternalServerError,
  HttpResponseMethodNotAllowed,
  HttpResponseMovedPermanently,
  HttpResponseNoContent,
  HttpResponseNotFound,
  HttpResponseNotImplemented,
  HttpResponseOK,
  HttpResponseRedirect,
  HttpResponseRedirection,
  HttpResponseServerError,
  HttpResponseSuccess,
  HttpResponseTooManyRequests,
  HttpResponseUnauthorized,
  isHttpResponse,
  isHttpResponseBadRequest,
  isHttpResponseClientError,
  isHttpResponseConflict,
  isHttpResponseCreated,
  isHttpResponseForbidden,
  isHttpResponseInternalServerError,
  isHttpResponseMethodNotAllowed,
  isHttpResponseMovedPermanently,
  isHttpResponseNoContent,
  isHttpResponseNotFound,
  isHttpResponseNotImplemented,
  isHttpResponseOK,
  isHttpResponseRedirect,
  isHttpResponseRedirection,
  isHttpResponseServerError,
  isHttpResponseSuccess,
  isHttpResponseTooManyRequests,
  isHttpResponseUnauthorized
});
