var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/middleware/force-https.ts
var force_https_default;
var init_force_https = __esm({
  "src/middleware/force-https.ts"() {
    force_https_default = (req, res, next) => {
      if (req.headers["x-forwarded-proto"] && req.headers["x-forwarded-proto"] !== "https") {
        res.redirect(`https://${req.hostname}${req.originalUrl}`);
      } else {
        next();
      }
    };
  }
});

// src/middleware/index.ts
var middleware_exports = {};
__export(middleware_exports, {
  asyncWrapMiddleware: () => import_async_express_mw.default,
  cookieParserMiddleware: () => import_cookie_parser.default,
  forceHttpsMiddleware: () => force_https_default,
  staticMiddleware: () => import_express.static
});
var import_cookie_parser, import_async_express_mw, import_express;
var init_middleware = __esm({
  "src/middleware/index.ts"() {
    import_cookie_parser = __toESM(require("cookie-parser"));
    import_async_express_mw = __toESM(require("async-express-mw"));
    import_express = require("express");
    init_force_https();
  }
});

// src/server/index.ts
var server_exports = {};
__export(server_exports, {
  HyperServer: () => HyperServer,
  createServer: () => createServer,
  listRoutes: () => list_routes_default,
  listen: () => listen_default,
  load: () => load_default,
  printRoutes: () => print_routes_default
});
module.exports = __toCommonJS(server_exports);

// src/server/hyperserver.ts
var import_helmet = __toESM(require("helmet"));
var import_compression = __toESM(require("compression"));
var import_hypernight = require("@hyperstackjs/hypernight");
var import_body_parser = require("body-parser");
var import_express_pino_logger = __toESM(require("express-pino-logger"));
var import_pino = __toESM(require("pino"));
var import_debug2 = __toESM(require("debug"));

// src/server/index-sender.ts
var import_path = __toESM(require("path"));
var import_fs = __toESM(require("fs"));
var indexSender = (indexFolder) => {
  const indexFile = import_path.default.resolve(indexFolder, "index.html");
  if (!import_fs.default.existsSync(indexFile)) {
    throw new Error(`controllers: index file redirect is on, but no such file: ${indexFile}`);
  }
  return (_req, res) => {
    res.sendFile(indexFile);
  };
};
var index_sender_default = indexSender;

// src/http/responses.ts
var HttpResponse = class {
  constructor(body, options = {}) {
    this.body = body;
    this.isHttpResponse = true;
    this.stream = false;
    this.headers = {};
    this.stream = options.stream || false;
  }
  setHeader(name, value) {
    this.headers[name] = value;
    return this;
  }
  getHeader(name) {
    return this.headers[name];
  }
  getHeaders() {
    return __spreadValues({}, this.headers);
  }
};
var HttpResponseClientError = class extends HttpResponse {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseClientError = true;
  }
};
var HttpResponseBadRequest = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseBadRequest = true;
    this.statusCode = 400;
    this.statusMessage = "BAD REQUEST";
  }
};
var HttpResponseNotFound = class extends HttpResponseClientError {
  constructor(body, options = {}) {
    super(body, options);
    this.isHttpResponseNotFound = true;
    this.statusCode = 404;
    this.statusMessage = "NOT FOUND";
  }
};

// src/http/response-sender.ts
var responseSender = (response, result) => {
  response.status(result.statusCode);
  response.set(result.getHeaders());
  if (typeof result.body === "number") {
    result.body = result.body.toString();
  }
  response.send(result.body);
};
var response_sender_default = responseSender;

// src/server/not-found.ts
var notFound = (req, res) => {
  response_sender_default(res, new HttpResponseNotFound());
};
var not_found_default = notFound;

// src/server/set-request-id.ts
var import_uuid = require("uuid");
var resolveId = (req, opts) => {
  switch (opts.mode) {
    case "generate": {
      return (0, import_uuid.v4)();
    }
    case "passthrough": {
      return req.id || req.get("x-request-id");
    }
    case "passthrough-or-generate": {
      return req.id || req.get("x-request-id") || (0, import_uuid.v4)();
    }
    case "none": {
      return null;
    }
  }
};
var setRequestId = (opts) => (req, res, next) => {
  req.id = resolveId(req, opts);
  if (req.id) {
    res.set("x-request-id", req.id);
  }
  next();
};
var set_request_id_default = setRequestId;

// src/server/error-handler.ts
var import_debug = __toESM(require("debug"));
var debug = (0, import_debug.default)("hypercontroller:error-handler");
var errorHandler = ({
  logger,
  sendValidationErrors = false
}) => async (err, req, res, next) => {
  debug("error %o", err);
  debug("sending validation errors out? %o", sendValidationErrors);
  if (err instanceof HttpResponse) {
    response_sender_default(res, err);
  } else if (err.isValidationError && sendValidationErrors) {
    response_sender_default(res, new HttpResponseBadRequest({
      error: "validation",
      validationErrors: err.errors
    }));
  } else if (err.isModelError) {
    response_sender_default(res, new HttpResponseBadRequest({ error: err.message }));
  } else if (err) {
    const resolvedLogger = req && req.logger ? req.logger : logger;
    if (resolvedLogger) {
      resolvedLogger.error({ err }, `Internal error`);
    }
    response_sender_default(res, new HttpResponseBadRequest({ error: "bad request" }));
  } else {
    next();
  }
};
var error_handler_default = errorHandler;

// src/server/hyperserver.ts
var debug2 = (0, import_debug2.default)("hyperserver");
var getOrCreateLogger = (opts) => {
  if (opts === false) {
    return null;
  }
  if (opts && opts !== true) {
    return opts;
  }
  debug2("creating logger");
  return (0, import_pino.default)();
};
var getOrCreateMiddleware = (logger, opts) => {
  if (opts === false) {
    return null;
  }
  if (opts && opts !== true) {
    return opts;
  }
  debug2("creating own logger middleware");
  return (0, import_express_pino_logger.default)({ logger });
};
var defaults = {
  helmet: void 0,
  json: { limit: "5mb" },
  urlencoded: { limit: "5mb", extended: true },
  requestIdOpts: { mode: "passthrough-or-generate" }
};
var isDefaultSetting = (s) => s === true || s === void 0;
var HyperServer = class extends import_hypernight.Server {
  constructor(controllers, opts) {
    const {
      cookieParserMiddleware: cookieParserMiddleware2,
      forceHttpsMiddleware,
      staticMiddleware: staticMiddleware2
    } = (init_middleware(), __toCommonJS(middleware_exports));
    super(process.env.NODE_ENV === "development");
    const {
      staticFolder,
      indexCatchAll,
      forceHttps,
      gzip,
      cookieSecret,
      logging,
      helmet: helmetOpts,
      json: jsonOpts,
      urlencoded: urlencodedOpts,
      requestId: requestIdOpts,
      sendValidationErrors,
      beforeControllers,
      afterControllers,
      beforeMiddleware,
      afterMiddleware
    } = opts;
    const logger = getOrCreateLogger(logging && logging.logger);
    const middleware = getOrCreateMiddleware(logger, logging && logging.middleware);
    if (beforeMiddleware) {
      beforeMiddleware(this.app);
    }
    if (requestIdOpts !== false) {
      const res = isDefaultSetting(requestIdOpts) ? defaults.requestIdOpts : requestIdOpts;
      this.app.use(set_request_id_default(res));
    }
    if (middleware) {
      this.app.use(middleware);
      this.app.use((req, res, next) => {
        ;
        req.logger = req.log || logger;
        if (next) {
          next();
        }
      });
    }
    if (forceHttps) {
      this.app.use(forceHttpsMiddleware);
    }
    if (gzip !== false) {
      const res = isDefaultSetting(gzip) ? void 0 : gzip;
      debug2("gzip: %o", res);
      this.app.use((0, import_compression.default)(res));
    }
    if (helmetOpts !== false) {
      const res = isDefaultSetting(helmetOpts) ? defaults.helmet : helmetOpts;
      debug2("helmet: %o", res);
      this.app.use((0, import_helmet.default)(res));
    }
    if (jsonOpts !== false) {
      const res = isDefaultSetting(jsonOpts) ? defaults.json : jsonOpts;
      debug2("json: %o", res);
      this.app.use((0, import_body_parser.json)(res));
    }
    if (urlencodedOpts !== false) {
      const res = isDefaultSetting(urlencodedOpts) ? defaults.urlencoded : urlencodedOpts;
      debug2("urlencoded: %o", res);
      this.app.use((0, import_body_parser.urlencoded)(res));
    }
    if (cookieSecret) {
      this.app.use(cookieParserMiddleware2(cookieSecret));
    }
    if (staticFolder) {
      this.app.use(staticMiddleware2(staticFolder));
    }
    if (beforeControllers) {
      beforeControllers(this.app);
    }
    super.addControllers(controllers);
    if (afterControllers) {
      afterControllers(this.app);
    }
    if (staticFolder && indexCatchAll) {
      this.app.get("*", index_sender_default(staticFolder));
    }
    this.app.use(not_found_default);
    this.app.use(error_handler_default({ logger, sendValidationErrors: !!sendValidationErrors }));
    if (afterMiddleware) {
      afterMiddleware(this.app);
    }
    ;
    this.app.__opts = opts;
  }
};
var createServer = ({
  controllers,
  opts = {}
}) => {
  const server = new HyperServer(controllers.map((K) => new K()), opts);
  return server.app;
};

// src/server/list-routes.ts
var import_path2 = __toESM(require("path"));
function getPathFromRegex(regexp) {
  return regexp.toString().replace("/^", "").replace("?(?=\\/|$)/i", "").replace(/\\\//g, "/");
}
function combineStacks(acc, stack) {
  if (stack.handle.stack) {
    const routerPath = getPathFromRegex(stack.regexp);
    return [
      ...acc,
      ...stack.handle.stack.map((stack2) => __spreadValues({ routerPath }, stack2))
    ];
  }
  return [...acc, stack];
}
function getStacks(app) {
  if (app.routes) {
    return Object.keys(app.routes).reduce((acc, method) => [...acc, ...app.routes[method]], []).map((route) => ({ route: { stack: [route] } }));
  }
  if (app._router && app._router.stack) {
    return app._router.stack.reduce(combineStacks, []);
  }
  if (app.stack) {
    return app.stack.reduce(combineStacks, []);
  }
  if (app.router && app.router.stack) {
    return app.router.stack.reduce(combineStacks, []);
  }
  return [];
}
function listRoutes(app) {
  const stacks = getStacks(app);
  const routes = [];
  if (stacks) {
    for (const stack of stacks) {
      if (stack.route) {
        const routeLogged = {};
        for (const route of stack.route.stack) {
          const method = route.method ? route.method.toUpperCase() : null;
          if (!routeLogged[method] && method) {
            const stackPath = stack.routerPath || route.path ? import_path2.default.resolve([stack.routerPath, stack.route.path, route.path].filter((s) => !!s).join("")) : stack.route.path;
            routes.push({ verb: method, path: stackPath });
            routeLogged[method] = true;
          }
        }
      }
    }
  }
  return routes;
}
var list_routes_default = listRoutes;

// src/server/print-routes.ts
var import_colorette = require("colorette");
var spacer = (verb, space = 8) => {
  const delta = space - verb.length;
  return verb + " ".repeat(delta);
};
var verbcolor = (verb) => {
  if (verb.startsWith("GET")) {
    return (0, import_colorette.green)(verb);
  } else if (verb.startsWith("DELETE")) {
    return (0, import_colorette.red)(verb);
  } else {
    return (0, import_colorette.yellow)(verb);
  }
};
var printRoutes = (app, log = console.log) => {
  const routes = list_routes_default(app);
  for (const route of routes) {
    log(`${verbcolor(spacer(route.verb))} ${route.path}`);
  }
};
var print_routes_default = printRoutes;

// src/server/load.ts
var import_path3 = __toESM(require("path"));
var import_glob = __toESM(require("glob"));
var load = (patt, cwd = process.cwd()) => import_glob.default.sync(import_path3.default.join(cwd, patt)).map((f) => {
  let mod = null;
  try {
    mod = require(f);
  } catch (e) {
    console.log(`error dynamically loading '${f}'
${e.toString()}`);
    throw e;
  }
  return mod.default || mod;
});
var load_default = load;

// src/server/listen.ts
var banner = (port) => `listening on port: ${port}`;
var listen = (app, opts = {}) => {
  const { port, bannerfn, log } = opts;
  const logfn = log || console.log;
  const resolvedPort = port || process.env.PORT || 5150;
  logfn((bannerfn || banner)(resolvedPort));
  app.listen(resolvedPort);
};
var listen_default = listen;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  HyperServer,
  createServer,
  listRoutes,
  listen,
  load,
  printRoutes
});
